{
 Unit ugdi32.pas  
 
 Author: Thomas Schnfelder
 
 Linked libs are copyrighted by Japeth and are part of his HXDOS project
 
 This unit is only the interface for the lib
}

unit ugdi32;

interface

uses gditypes;

{.$DEFINE CALLCONV := stdcall}
{define read_interface}
{$i gdi_base.inc}
{$i gdi_struct.inc}
{$i gdi_msg.inc}

type
  tagRGBQUAD = record
  rgbBlue    : Byte;
  rgbGreen   : Byte;
  rgbRed     : Byte;
  rgbReserved: Byte;
  end;
  RGBQUAD = tagRGBQUAD;
  PRGBQUAD = ^RGBQUAD;
  LPRGBQUAD = PRGBQUAD;

  tagDOCINFO = record
    cbSize      : Longint;
    lpszDocName : LPCTSTR;
    lpszOutput  : LPCTSTR;
    lpszDatatype: LPCTSTR;
    fwType      : DWORD;
  end;
  DOCINFO = tagDOCINFO;
  PDOCINFO = ^DOCINFO;
  LPDOCINFO = PDOCINFO;

{$Linklib Dgdi32}

{
const
  AD_COUNTERCLOCKWISE = 1;
  AD_CLOCKWISE        = 2;
}

var _theArcDirection_: Longint = 0;

function AddFontResourceA(lpszFilename: LPCTSTR): Longint; stdcall; external;        
function AnimatePalette(hpal: HPALETTE; iStartIndex, uEntries: UINT; const ppe: PPALETTEENTRY): BOOL; stdcall; external;

function SetArcDirection(aHDC: HDC; ArcDirection: Longint): Longint;
function Arc(aHDC: HDC; nLeft,nTop,nRight,nBottom,nXStartArc,nYStartArc,nXEndArc,nYEndArc: Longint): BOOL; stdcall; external;  { is Dummy (Y) }

function BitBlt(hcDest: HDC; nxDest,nyDest,nWidth,nHeight: Longint; hdcSrc: HDC; nx,ny: Longint; dwRop: DWORD): BOOL; stdcall; external;                   

function ChoosePixelFormat(aHDC: HDC; ppcd: PPIXELFORMATDESCRIPTOR): Longint; stdcall; external;              { is Dummy (Y) }
function CloseEnhMetaFile(aHDC: HDC): HENHMETAFILE; stdcall; external;                                        { is Dummy (Y) }
function CopyEnhMetaFileA(hemfSrc: HENHMETAFILE; lpstfile: LPCTSTR): HENHMETAFILE; stdcall; external;         { is Dummy (Y) }
function CopyEnhMetaFileW(hemfSrc: HENHMETAFILE; lpstfile: LPCTSTR): HENHMETAFILE; stdcall; external;         { is Dummy (Y) }
function CopyMetaFileA(hemfSrc: HMETAFILE; lpstfile: LPCTSTR): HMETAFILE; stdcall; external;                  { is Dummy (Y) }
function CopyMetaFileW(hemfSrc: HMETAFILE; lpstfile: LPCTSTR): HMETAFILE; stdcall; external;                  { is Dummy (Y) }

function CombineRgn(hrgnDst,hrgnSrc1,hrgnSrc2: HRGN; fnCombineMode: Longint): Longint; stdcall; external;
function CreateBitmap(nWidth,nHeight: Longint; cPlanes,cBitsPerPel: UINT; const lpvBits: Pointer): HBITMAP; stdcall; external;
function CreateBrushIndirect(const lplb: PLOGBRUSH): HBRUSH; stdcall; external;

function CreateColorSpaceA(lplgColorSpace: LPLOGCOLORSPACE): HCOLORSPACE; {WINAPI} stdcall; external;         { is Dummy (Y) }
function CreateColorSpaceW(lplgColorSpace: LPLOGCOLORSPACE): HCOLORSPACE; {WINAPI} stdcall; external;         { is Dummy (Y) }

function CreateCompatibleBitmap(aHDC: HDC; nWidth,nHeight: Longint): HBITMAP; stdcall; external;
function CreateCompatibleDC(aHdc: HDC): HDC; stdcall; external;
function CreateDC(lpszDriver,lpszDevice,lpszOutput: LPCTSTR; const lpInitData: PDEVMODE): HDC; stdcall; external;                
function CreateDIBitmap(
         aHDC: HDC; 
   const lpBmih: PBITMAPINFOHEADER; 
         fdwInit: DWORD; 
   const lpbInit: Pointer; 
   const lpBmi: PBITMAPINFO; 
   fuUsage: UINT
   ): HBITMAP; stdcall; external;

function CreateDIBSection(
        aHDC: HDC;
  const pbmi: PBITMAPINFO;
        iUsage: UINT;       
  Out   ppvBits: Pointer;
        hSection: HANDLE;
        dwOffset: DWORD      
   ): HBITMAP; stdcall; external;
   
   
function CreateEnhMetaFileA(       { is Dummy (Y) }
        hdcRef: HDC;
        lpFilename: LPCTSTR;
  const lpRect: PRECT;
        lpDescription: LPCTSTR 
   ): HDC; stdcall; external;
 
function CreateFontA(
   nHeight: Longint;     
   nWidth: Longint;
   nEscapement: Longint;     
   nOrientation: Longint;     
   fnWeight: Longint;     
   fdwItalic: DWORD;   
   fdwUnderline: DWORD;   
   fdwStrikeOut: DWORD;   
   fdwCharSet: DWORD;   
   fdwOutputPrecision: DWORD;
   fdwClipPrecision: DWORD;
   fdwQuality: DWORD;
   fdwPitchAndFamily: DWORD;
   lpszFace: LPCTSTR
   ): HFONT; stdcall; external;
function CreateFontW(
   nHeight: Longint;     
   nWidth: Longint;
   nEscapement: Longint;     
   nOrientation: Longint;     
   fnWeight: Longint;     
   fdwItalic: DWORD;   
   fdwUnderline: DWORD;   
   fdwStrikeOut: DWORD;   
   fdwCharSet: DWORD;   
   fdwOutputPrecision: DWORD;
   fdwClipPrecision: DWORD;
   fdwQuality: DWORD;
   fdwPitchAndFamily: DWORD;
   lpszFace: LPCTSTR
 ): HFONT; stdcall; external;
function CreateFontIndirectA(const lplf: PLOGFONT): HFONT; stdcall; external;
function CreateFontIndirectW(const lplf: PLOGFONT): HFONT; stdcall; external;
 
function CreateMetaFileA(lpszFile: LPCTSTR): HDC; stdcall; external;         { is Dummy (Y) }
function CreateMetaFileW(lpszFile: LPCTSTR): HDC; stdcall; external;         { is Dummy (Y) }
 
function CreatePalette(const lplgpl: LOGPALETTE): HPalette; stdcall; external;
function CreatePatternBrush(hbmp: HBITMAP): HBRUSH; stdcall; external;
function CreatePen(
   fnPenStyle: Longint;
   nWidth: Longint;
   crColor: COLORREF 
  ): HPEN; stdcall; external;
function CreateRectRgn(
   nLeftRect: Longint; 
   nTopRect: Longint; 
   nRightRect: Longint; 
   nBottomRect: Longint
  ): HRGN; stdcall; external;
function CreateRectRgnIndirect(const lprc:PRECT): HRGN; stdcall; external;
function CreateSolidBrush(crColor: COLORREF): HBRUSH; stdcall; external;
function DeleteDC(aHDC: HDC): BOOL; stdcall; external;
 
function DeleteEnhMetaFile(hemf: HENHMETAFILE): BOOL; stdcall; external;       { is Dummy (Y) }
 
function DeleteObject(hObject: HGDIOBJ): BOOL; stdcall; external;


function DescribePixelFormat(
   aHDC: HDC;
   iPixelFormat: Longint;
   nBytes: UINT;
   ppfd: LPPIXELFORMATDESCRIPTOR
 ): Longint; {WINAPI} stdcall; external;   { is Dummy (Y) }
function Ellipse(
   aHDC: HDC;
   nLeftRect: Longint;
   nTopRect: Longint;
   nRightRect: Longint;
   nBottomRect: Longint
 ): BOOL; stdcall; external;            { is Dummy (Y) }
function EnumFontFamiliesA(
   aHDC: HDC;
   lpszFamily: LPCTSTR;
   lpEnumFontFamProc: FONTENUMPROC;
   lParam: LPARAM
 ): Longint; stdcall; external;            { is Dummy (Y) }
function EnumFontFamiliesExA(
   aHDC: HDC;
   alpLogfont: LPLOGFONT;
   lpEnumFontFamExProc: FONTENUMPROC;
   alParam: LPARAM;
   dwFlags: DWORD
 ): Longint; stdcall; external;            { is Dummy (Y) }
 
function ExtCreatePen(
         dwPenStyle: DWORD;
         dwWidth: DWORD;
   const lplb: PLOGBRUSH;
         dwStyleCount: DWORD;
   const lpStyle: PDWORD
 ): HPEN; stdcall; external; 
function ExtCreateRegion(
   const lpXform: PXFORM;
         nCount: DWORD;
   const lpRgnData: PRGNDATA
 ): HRGN; stdcall; external;
 
function ExtTextOutA(
         aHDC: HDC;
         X: Longint;
         Y: Longint;
         fuOptions: UINT;
   const lprc: PRECT;
         lpString: LPCTSTR;
         cbCount: UINT;
   const lpDx: PINTEGER
 ): BOOL; stdcall; external;

function ExtTextOutW(
         aHDC: HDC;
         X: Longint;
         Y: Longint;
         fuOptions: UINT;
   const lprc: PRECT;
         lpString: LPCTSTR;
         cbCount: UINT;
   const lpDx: PINTEGER
 ): BOOL; stdcall; external;

function FillRect(dc: HDC; const Rect: TRect; Brush: HBRUSH): Longint;

function FillRgn(
  aHDC: HDC;
   hrg: HRGN;
   hbr: HBRUSH
 ): BOOL; stdcall; external;
 
 
function FloodFill(
   aHDC: HDC;
   nXStart: Longint;
   nYStart: Longint;
   crFill: COLORREF
 ): BOOL; stdcall; external;                                       { is Dummy (Y) }
              
function GdiFlush: BOOL; stdcall; external;                        { is Dummy (Y) }
function GdiSetBatchLimit(dwLimit: DWORD): DWORD; stdcall; external;  { is Dummy (Y) }
 
function GetBitmapBits(
   hbmp: HBITMAP;
   cbBuffer: LONG;
   lpvBits: LPVOID
  ): LONG; stdcall; external;
 
function GetBitmapDimensionEx(hBmp: HBITMAP; lpDimension: LPSIZE): BOOL; stdcall; external;    { is Dummy (Y) }
function GetBkColor(aHDC: HDC): COLORREF; stdcall; external;


function GetCharacterPlacementA(                                       { is Dummy (Y) }
      aHDC: HDC;
      lpString: LPCTSTR;
      nCount: Longint;
      nMaxExtent: Longint;
  out lpResults: LPGCP_RESULTS;
      dwFlags: DWORD
  ): DWORD; stdcall; external;
function GetCharacterPlacementW(                                       { is Dummy (Y) }
      aHDC: HDC;
      lpString: LPCTSTR;
      nCount: Longint;
      nMaxExtent: Longint;
  out lpResults: LPGCP_RESULTS;
      dwFlags: DWORD
  ): DWORD; stdcall; external;
function GetCharABCWidthsA(                                            { is Dummy (Y) }
    aHDC: HDC;
    uFirstChar: UINT;
    uLastChar: UINT;
   out lpabc: LPABC
  ): BOOL; stdcall; external;
function GetCharABCWidthsW(                                            { is Dummy (Y) }
    aHDC: HDC;
    uFirstChar: UINT;
    uLastChar: UINT;
   out lpabc: LPABC
  ): BOOL; stdcall; external;


function GetCharWidth32A(
      aHDC: HDC;
      iFirstChar: UINT;
      iLastChar: UINT;
  out lpBuffer: LPINT
 ): BOOL; stdcall; external;
 
function GetCharWidth32W(
      aHDC: HDC;
      iFirstChar: UINT;
      iLastChar: UINT;
  out lpBuffer: LPINT
 ): BOOL; stdcall; external;

function GetCharWidthA( 
    aHDC: HDC;
    iFirstChar: UINT;
    iLastChar: UINT;
    lpBuffer: LPINT
 ): BOOL; stdcall; external;
function GetCharWidthW(
    aHDC: HDC;
    iFirstChar: UINT;
    iLastChar: UINT;
    lpBuffer: LPINT
 ): BOOL; stdcall; external;
function GetClipBox(aHDC: HDC; out lprc: LPRECT): Longint; stdcall; external;
function GetCurrentObject(aHDC: HDC; uObjectType: UINT): HGDIOBJ; stdcall; external;
function GetCurrentPositionEx(aHDC: HDC; out lpPnt: LPPOINT): BOOL; stdcall; external;
function GetDCOrgEx(aHDC: HDC; out lpPnt: LPPOINT): BOOL; stdcall; external;
function GetDCBrushColor(aHDC: HDC): COLORREF; stdcall; external;
function GetDCPenColor(aHDC: HDC): COLORREF; stdcall; external;
function GetDeviceCaps(aHDC: HDC; nIndex: Longint): Longint; stdcall; external;

function GetDeviceGammaRamp(aHDC: HDC; lpRamp: LPVOID): BOOL; {WINAPI} stdcall; external;      { is Dummy (Y) }

function GetDIBColorTable(
    aHDC: HDC;
    uStartIndex: UINT;
    cEntries: UINT;
   out pColors: PRGBQUAD
): UINT; stdcall; external;

function GetDIBits(
     ahdc: HDC;
     hbmp: HBITMAP;
     uStartScan: UINT;
     cScanLines: UINT;
   out  lpvBits: LPVOID;
   var  lpbi: LPBITMAPINFO;       {in and out}
        uUsage: UINT
 ): Longint; stdcall; external;
function GetEnhMetaFileBits(      { is Dummy (Y) }
     hemf: HENHMETAFILE;
     cbBuffer: UINT;
 out lpbBuffer: LPBYTE
 ): UINT; stdcall; external;

function GetEnhMetaFileHeader(     { is Dummy (Y) }
      hemf: HENHMETAFILE;
      cbBuffer: UINT;
  out lpemh: LPENHMETAHEADER
 ): UINT; stdcall; external;

function GetFontData(              { is Dummy (Y) }
      aHDC: HDC;
      dwTable: DWORD;
      dwOffset: DWORD;
  Out lpvBuffer: LPVOID;
      cbData: DWORD
 ): DWORD; stdcall; external;
function GetMapMode(aHDC: HDC): Longint; stdcall; external;
function GetNearestPaletteIndex(hpal: HPALETTE; crColor: COLORREF): UINT; stdcall; external;
function GetObjectA(
   gdiobj: HGDIOBJ;
   cbBuffer: Longint;
   out lpvObject: LPVOID
 ): Longint; stdcall; external;
function GetObjectType(h: HGDIOBJ): DWORD; stdcall; external;

function GetOutlineTextMetricsA(   { is Dummy (Y) }
  aHDC:   HDC;
  cbData: UINT;
  lpOTM:  LPOUTLINETEXTMETRIC
 ): UINT; stdcall; external;

function GetOutlineTextMetricsW(   { is Dummy (Y) }
  aHDC:   HDC;
  cbData: UINT;
  lpOTM:  LPOUTLINETEXTMETRIC
 ): UINT; stdcall; external;

function GetPaletteEntries(
   hpal: HPALETTE;
   iStartIndex: UINT;
   nEntries: UINT;
   out lppe: LPPALETTEENTRY
 ): UINT; stdcall; external;

function GetPixel(
  dc: HDC;
  nXPos: Longint;
  nYPos: Longint
 ): COLORREF; stdcall; external;

function GetPixelFormat(dc: HDC): Longint; stdcall; external;           { is Dummy (Y) }

function GetRegionData(
    Rgn: HRGN;
    dwCount: DWORD;
  out lpRgnDat: LPRGNDATA
 ): DWORD; stdcall; external;

function GetRgnBox(
     rgn: HRGN;
 Out lprc: LPRECT
): Longint; stdcall; external;

function GetROP2(dc: HDC): Longint;                 { is Dummy (Y) }

function GetStockObject(
 fnObject: LOngint
 ): HGDIOBJ; stdcall; external;

function GetSystemPaletteEntries(
  aHDC: HDC;
  iStartIndex: UINT;
  nEntries   : UINT;
  Out lppe: LPPALETTEENTRY
 ): UINT; stdcall; external;

function GetSystemPaletteUse(dc: HDC): UINT; stdcall; external;

function GetTextAlign(dc:HDC): UINT; stdcall; external;
function GetTextCharset(dc: HDC): Longint; stdcall; external;
function GetTextCharsetInfo(
  dc:      HDC;
  Out lpSig: LPFONTSIGNATURE;
  dwFlags: DWORD           
 ): Longint; stdcall; external;

function GetTextColor(dc: HDC): COLORREF; stdcall; external;

function GetTextExtentPoint32A(
  dc: HDC;
  str: LPCSTR;
  count: Longint;
  out size: LPSIZE
 ): BOOL; stdcall; external;
function GetTextExtentPoint32W(
  dc: HDC;
  str: LPCSTR;
  count: Longint;
  out size: LPSIZE
 ): BOOL; stdcall; external;
function GetTextExtentPointA(
    dc: HDC;
    lpString: LPCTSTR;
    cbString: Longint;
  Out Size: LPSIZE
): BOOL; stdcall; external;
function GetTextExtentPointW(
    dc: HDC;
    lpString: LPCTSTR;
    cbString: Longint;
  Out Size: LPSIZE
): BOOL; stdcall; external;
function GetTextFaceA(
    dc: HDC;
    nCount: Longint;
  Out lpFaceName: LPTSTR
 ): Longint; stdcall; external;

function GetTextFaceW(
   dc: HDC;
   nCount: Longint;
  Out lpFaceName: LPTSTR
 ): Longint; stdcall; external;
function GetTextMetricsA(
  dc: HDC;
  Out lptm: LPTEXTMETRICA
 ): BOOL; stdcall; external;
function GetViewportExtEx(dc: HDC; out pSize: LPSIZE): BOOL; stdcall; external;
function GetViewportOrgEx(dc: HDC; out pPnt: LPPOINT): BOOL; stdcall; external;
function GetWindowExtEx(dc: HDC; out pSize: LPSIZE): BOOL; stdcall; external;
function GetWindowOrgEx(dc: HDC; out pPnt: LPPOINT): BOOL; stdcall; external;

function GetWorldTransform(dc: HDC; pxForm: LPXFORM): BOOL; stdcall; external;        { is Dummy (Y) }

function IntersectClipRect(
  dc: HDC;
  nLeftRect: Longint;
  nTopRect : Longint;
  nRightRect: Longint;
  nBottomRect: Longint
 ): Longint; stdcall; external;

function LineTo(dc: HDC; nxEnd, nYEnd: Longint): BOOL; stdcall; external;


function MaskBlt(                  { is Dummy (Y) }
  hdcDest: HDC;                    { is Dummy (Y) }
  nXDest : Longint;                { is Dummy (Y) }
  nYDest : Longint;                { is Dummy (Y) }
  nWidth : Longint;                { is Dummy (Y) }
  nHeight: Longint;                { is Dummy (Y) }
  hdcSrc : HDC;                    { is Dummy (Y) }
  nXSrc  : Longint;                { is Dummy (Y) }
  nYSrc  : Longint;                { is Dummy (Y) }
  hbmMask: HBITMAP;                { is Dummy (Y) }
  xMask  : Longint;                { is Dummy (Y) }
  yMask  : Longint;                { is Dummy (Y) }
  dwRop  : DWORD                   { is Dummy (Y) }
 ): BOOL; stdcall; external;   { is Dummy (Y) }
 
 
function MoveToEx(
      dc: HDC;
      X: Longint;
      Y: Longint;
  Out pPoint: LPPOINT
 ): BOOL; stdcall; external;

function OffsetClipRgn(dc: HDC; nXOffset, nYOffset: Longint): Longint; stdcall; external;
 
function OffsetRgn(rgn: HRGN; nXOffset, nYOffset: Longint): Longint; stdcall; external;
function OffsetViewportOrgEx (
          dc: HDC;
    nXOffset: Longint;
    nYOffset: Longint;
  Out pPoint:  LPPOINT
): BOOL; stdcall; external;

function OffsetWindowOrgEx(
          dc: HDC;
    nXOffset: Longint;
    nYOffset: Longint;
  Out pPoint:  LPPOINT
 ): BOOL; stdcall; external;
 
function PaintRgn(dc: HDC; rgn: HRGN): BOOL; stdcall; external;

function PatBlt(
   dc: HDC;
   nXLeft : Longint;
   nYLeft : Longint;
   nWidth : Longint;
   nHeight: Longint;
   dwRop: DWORD
 ): BOOL; stdcall; external;

function Pie(                      { is Dummy (Y) }
  dc: HDC;
  nLeftRect: Longint;
  nTopRect: Longint;
  nRightRect: Longint;
  nBottomRect: Longint;
  nXRadial1: Longint;
  nYRadial1: Longint;
  nXRadial2: Longint;
  nYRadial2: Longint
): BOOL; stdcall; external;


function PlayEnhMetaFile(          { is Dummy (Y) }
        dc   : HDC;
        hemf : HENHMETAFILE;
  const pRect: LPRECT
 ): BOOL; stdcall; external;
function PlayEnhMetaFileRecord(    { is Dummy (Y) }
         dc: HDC;
         pHandletable: LPHANDLETABLE;
   const pEnhMetaRecord: LPENHMETARECORD;
         nHandles: UINT
 ): BOOL; stdcall; external;


function Polygon(
         dc: HDC;
   const pPoints: LPPOINT;
         nCount: Longint
 ): BOOL; stdcall; external;

function Polyline(
         dc: HDC;
   const lppt: LPPOINT;
         cPoints: Longint
): BOOL; stdcall; external;

function PolyPolyline(             { is Dummy (Y) }
         dc: HDC;
   const lppt: LPPOINT;
   const lpdwPolyPoints: PDWORD;
         cCount: DWORD
 ): BOOL; stdcall; external;

function PtVisible(                { is Dummy (Y) }
  dc: HDC;
  X: Longint;
  Y: Longint
 ): BOOL; stdcall; external;

 
function RealizePalette(dc: HDC): UINT; stdcall; external;
function Rectangle(
  dc: HDC;
  nLeftRect: Longint;
  nTopRect: Longint;
  nRightRect: Longint;
  nBottomRect: Longint
 ): BOOL; stdcall; external;


function RectVisible(dc: HDC; const lprc: LPRECT): BOOL; stdcall; external;               { is Dummy (Y) }
 
 
function ResizePalette(
  hpal: HPALETTE;
  nEntries: UINT
 ): BOOL; stdcall; external;

 
function ScaleViewportExtEx(       { is Dummy (Y) }
      dc:  HDC;
      Xnum:  Longint;
      Xdenom:  Longint;
      Ynum:  Longint;
      Ydenom:  Longint;
  Out pSize: LPSIZE
 ): BOOL; stdcall; external;
function ScaleWindowExtEx(         { is Dummy (Y) }
     dc    : HDC;
     Xnum  : Longint;
     Xdenom: Longint;
     Ynum  : Longint;
     Ydenom: Longint;
  Out pSize: LPSIZE
 ): BOOL; stdcall; external;
function SelectClipRgn(dc: HDC; rgn: HRGN): Longint; stdcall; external;
function SelectObject(dc: HDC; gdiobj: HGDIOBJ): HGDIOBJ; stdcall; external;
function SelectPalette(
  dc: HDC;
  hpal: HPALETTE;
  bForceBackground: BOOL
 ): HPALETTE; stdcall; external;

function SetBitmapBits(
        hbmp  : HBITMAP;
        cBytes: DWORD;
  const lpBits: Pointer
 ): Longint; stdcall; external;

function SetBitmapDimensionEx(     { is Dummy (Y) }
      hBitmap: HBITMAP;
      nWidth : Longint;
      nHeight: Longint;
  Out pSize: LPSIZE
 ): BOOL; stdcall; external;

function SetBkColor(dc: HDC; crColor: COLORREF): COLORREF; stdcall; external;
function SetBkMode(dc: HDC; iBkMode: Longint): Longint; stdcall; external;

function SetDCBrushColor(aHDC: HDC; crColor: COLORREF): COLORREF; stdcall; external;
function SetDCPenColor(aHDC: HDC; crColor: COLORREF): COLORREF; stdcall; external;


function SetDeviceGammaRamp(       { is Dummy (Y) }
  dc: HDC;
  lpRamp: Pointer
): BOOL; {WINAPI} stdcall; external;


function SetDIBColorTable(
         dc: HDC;
         uStartIndex: UINT;
         cEntries: UINT;
   const pColors: LPRGBQUAD
 ): UINT; stdcall; external;

function SetDIBits(
         dc: HDC;
         hbmp: HBITMAP;
         uStartScan: UINT;
         cScanLines: UINT;
   const lpvBits: Pointer;
   const lpbmi: LPBITMAPINFO;
         fuColorUse: UINT
 ): Longint; stdcall; external;

function SetDIBitsToDevice(
         dc: HDC;
         XDest: Longint;
         YDest: Longint;
         dwWidth: DWORD;
         dwHeight: DWORD;
         XSrc: Longint;
         YSrc: Longint;
         uStartScan: UINT;
         cScanLines: UINT;
   const lpvBits: Pointer;
   const lpbmi: LPBITMAPINFO;
         fuColorUse: UINT
 ): Longint; stdcall; external;

function SetEnhMetaFileBits(       { is Dummy (Y) }
         cbBuffer: UINT;
   const lpData: PBYTE
): HENHMETAFILE; stdcall; external;


function SetMapMode(dc: HDC; fnMapMode: Longint): Longint; stdcall; external;

function SetPaletteEntries(
         hpal    : HPALETTE;
         iStart  : UINT;
         cEntries: UINT;
   const lppe: LPPALETTEENTRY
 ): UINT; stdcall; external;

function SetPixel(
  dc: HDC;
  X: Longint;
  Y: Longint;
  crColor: COLORREF
): COLORREF; stdcall; external;

function SetPixelFormat(           { is Dummy (Y) }
         dc: HDC;
         iPixelFormat: Longint;
   const ppfd: LPPIXELFORMATDESCRIPTOR
 ): BOOL; {WINAPI} stdcall; external;

function SetRectRgn( 
   rgn        : HRGN;
   nLeftRect  : Longint;
   nTopRect   : Longint;
   nRightRect : Longint;
   nBottomRect: Longint
 ): BOOL; stdcall; external;

function SetROP2(dc: HDC; fnDrawMode: Longint): Longint; stdcall; external;               { is Dummy (Y) }
function SetStretchBltMode(dc: HDC; iStretchMode: Longint): Longint; stdcall; external;
function SetTextAlign(dc: HDC; fmode: UINT): UINT; stdcall; external;
function SetTextColor(dc: HDC; crColor: COLORREF): COLORREF; stdcall; external;
function SetViewportExtEx(
    dc:HDC;
    nXExtent: Longint;
    nYExtent: Longint;
  Out pSize: LPSIZE
): BOOL; stdcall; external;
function SetViewportOrgEx(
    dc: HDC;
    X: Longint;
    Y: Longint;
  Out pPoint: LPPOINT
): BOOL; stdcall; external;
function SetWindowExtEx(
    dc:HDC;
    nXExtent: Longint;
    nYExtent: Longint;
  Out pSize: LPSIZE
): BOOL; stdcall; external;

function SetWindowOrgEx(
    dc: HDC;
    X: Longint;
    Y: Longint;
  Out pPoint: LPPOINT
): BOOL; stdcall; external;

function SetWorldTransform(dc: HDC; const pXForm: LPXFORM): BOOL; stdcall; external;    { is Dummy (Y) }
function StartDocA(dc: HDC; const lpdi: LPDOCINFO): Longint; stdcall; external;            { is Dummy (Y) }
function StartDocW(dc: HDC; const lpdi: LPDOCINFO): Longint; stdcall; external;            { is Dummy (Y) }

function StretchBlt(               { is Dummy (Y) }
  hdcDest: HDC;
  nXOriginDest: Longint;
  nYOriginDest: Longint;
  nWidthDest  : Longint;
  nHeightDest : Longint;
  hdcSrc      : HDC;
  nXOriginSrc : Longint;
  nYOriginSrc : Longint;
  nWidthSrc   : Longint;
  nHeightSrc  : Longint;
  dwRop       : DWORD
  ): BOOL; stdcall; external;
function StretchDIBits(            { is Dummy (Y) }
         dc         : HDC;
         XDest      : Longint;
         YDest      : Longint;
         nDestWidth : Longint;
         nDestHeight: Longint;
         XSrc       : Longint;
         YSrc       : Longint;
         nSrcWidth  : Longint;
         nSrcHeight : Longint;
   const lpBits     : Pointer;
   const lpBitsInfo : LPBITMAPINFO;
         iUsage     : UINT;
         dwRop      : DWORD
   ): Longint; stdcall; external;
   
function SwapBuffers(dc: HDC): BOOL; {WINAPI} stdcall; external;    { is Dummy (Y) }
 
function TextOutA(    
  dc: HDC;
  nXStart: Longint;
  nYStart: Longint;
  lpString: LPCTSTR;
  cchString: Longint
): BOOL; stdcall; external;

function TextOutW(
  dc: HDC;
  nXStart: Longint;
  nYStart: Longint;
  lpString: LPCTSTR;
  cchString: Longint
): BOOL; stdcall; external;
 
function TranslateCharsetInfo(     { is Dummy (Y) }
  var lpSrc: LPDWORD;
  out lpCs : LPCHARSETINFO;
      dwFlags: DWORD
 ): BOOL; stdcall; external;

function UnrealizeObject(gdiobj: HGDIOBJ): BOOL; stdcall; external;   { is Dummy (Y) }
function UpdateColors(dc: HDC): BOOL; stdcall; external;              { is Dummy (Y) }

implementation

{$undef read_interface}
{$define read_implementation}
{$i gdi_base.inc}
{$i gdi_struct.inc}
{$i gdi_msg.inc}

function SetArcDirection(aHDC: HDC; ArcDirection: Longint): Longint;
begin
  Result := _theArcDirection_;
  _theArcDirection_ := ArcDirection;
end;

function GetROP2(dc: HDC): Longint;
begin

end;

function FillRect(dc: HDC; const Rect: TRect; Brush: HBRUSH): Longint;
begin
  //Rectangle(dc, Rect.Left, Rect.Top, Rect.Right, Rect.Bottom);
  //FillRect := Longint(FloodFill(dc, (Rect.Left + Rect.Right) div 2, (Rect.Top + Rect.Bottom) div 2, GetDCBrushColor(dc)));
  FillRect := Longint(FillRgn(dc, CreateRectRgn(Rect.Left, Rect.Top, Rect.Right, Rect.Bottom), Brush));
end;

{$undef read_implementation}

end.
