{
 Unit uuser32.pas  
 
 Author: Thomas Schnfelder
 
 Linked libs are copyrighted by Japeth and are part of his HXDOS project
 
 This unit is only the interface for the lib
}

unit uuser32;

interface

uses
  Classes;

{$MACRO ON}
{$DEFINE callconv := stdcall}

{$define read_interface}
{$i gdi_base.inc}
{$i gdi_struct.inc}
{$i gdi_msg.inc}

{$Linklib Duser32}

const   CCHILDREN_TITLEBAR = 5;

type
  //UINT_PTR = ^LongWord;
  //HKL = WORD;
  {
  tagTITLEBARINFO = record
    cbSize: DWORD;          sizeof(TITLEBARINFO)
    rcTitleBar: RECT;
    rgstate: array[CCHILDREN_TITLEBAR+1] of DWORD;
  end;
  TITLEBARINFO = tagTITLEBARINFO;
  PTITLEBARINFO = ^TITLEBARINFO;
  LPTITLEBARINFO = PTITLEBARINFO;

  tagWINDOWPLACEMENT = record
    length           : UINT;
    flags            : UINT;
    showCmd          : UINT;
    ptMinPosition    : POINT;
    ptMaxPosition    : POINT;
    rcNormalPosition : RECT;
  end;
  WINDOWPLACEMENT = tagWINDOWPLACEMENT;
  PWINDOWPLACEMENT = ^WINDOWPLACEMENT;
  }
  HINSTANCE = PtrUINT;
  LPWINDOWPLACEMENT = PWINDOWPLACEMENT;

  tagTITLEBARINFO = record
    cbSize: DWORD;
    rcTitleBar: RECT;
    rgstate: array[0..CCHILDREN_TITLEBAR+1] of DWORD;
  end;
  TITLEBARINFO = tagTITLEBARINFO;
  PTITLEBARINFO = ^TITLEBARINFO;
  LPTITLEBARINFO = PTITLEBARINFO;

  { THandleList }

  THandleList = class(TList)
  private
    function GetHandle(Index: Integer): THandle;
  public
    function Add(h: THandle): Integer;
    property Handle[Index: Integer]: THandle read GetHandle;
  end;

  { THandleStack }

  THandleStack = class(THandleList)
  private
    FCurrentHandle: THandle;
    FCurrentIndex: Integer;
  public
    function Empty: Boolean;
    procedure push(H: THandle);
    procedure pop(out H: THandle);
    property CurrentHandle: THandle read FCurrentHandle;
  end;

function AdjustWindowRect(
  var lpRc: LPRECT;
   dwStyle: DWORD;
   bMenu  : BOOL
  ): BOOL; callconv; external; {WINAPI}
function AdjustWindowRectEx(         { is Dummy (Y) }
  var lpRc: LPRECT;
   dwStyle: DWORD;
   bMenu  : BOOL;
 dwExStyle: DWORD
 ): BOOL; callconv; external; {WINAPI}
function AppendMenuA(
   hMen: HMENU;
   uFlags:UINT;
   uIDNewItem: UINT_PTR;
   lpNewItem: LPCTSTR = nil
 ): BOOL; callconv; external; {WINAPI}

function BeginPaint(wnd: HWND; out lpPaint: LPPAINTSTRUCT): HDC; callconv; external; 
function BroadcastSystemMessage(     { is Dummy (Y) }
   dwFlags: DWORD;
   lpdwRecipients: LPDWORD;
   uiMessage: UINT;
   wwParam: WPARAM;
   llParam: LPARAM
 ): Longint; callconv; external; {WINAPI}
function BringWindowToTop(wnd: HWND): BOOL; callconv; external; {WINAPI}

function CallNextHookEx(             { is Dummy (Y) }
   hhk: HHOOK;
   nCode: Longint;
   wwParam: WPARAM;
   llParam: LPARAM
 ): LRESULT {WINAPI}; callconv; external;

function CallWindowProcA(
   lpPrevWndFunc: WNDPROC;
   Wnd: HWND;
   Msg: UINT;
   wwParam: WPARAM;
   llParam: LPARAM
): LRESULT {WINAPI}; callconv; external;


function ChangeClipboardChain(       { is Dummy (Y) }
  hWndRemove : HWND;
  hWndNewNext: HWND
): BOOL; {WINAPI} callconv; external;

function ChangeDisplaySettingsA(
  lpDevMode: LPDEVMODE;
  dwflags: DWORD
): Longint; callconv; external;

function CharLower(lpsz: LPTSTR): LPTSTR; {callconv; external;} {WINAPI}
function CharLowerA(lpsz: LPTSTR): LPTSTR; callconv; external; {WINAPI}
function CharLowerW(lpsz: LPTSTR): LPTSTR; callconv; external; {WINAPI}

function CharLowerBuff(
  lpsz: LPTSTR;
  cchLength: DWORD
): DWORD; {WINAPI} 

function CharLowerBuffA(
  lpsz: LPTSTR;
  cchLength: DWORD
): DWORD; {WINAPI} callconv; external;

function CharLowerBuffW(
  lpsz: LPTSTR;
  cchLength: DWORD
): DWORD; {WINAPI} callconv; external;

function CharNext(lpsz: LPCTSTR): LPTSTR;
function CharNextA(
  lpsz: LPCTSTR
): LPTSTR; {WINAPI} callconv; external;

function CharNextExA(
   CodePage: WORD;
   lpCurrentChar: LPCSTR;
   dwFlags: DWORD
): LPSTR; {WINAPI} callconv; external;

function CharNextW(lpsz: LPCWSTR): LPWSTR; {WINAPI} callconv; external;
function CharPrevA(start, ptr: LPCStr): LPSTR; {WINAPI} callconv; external;
function CharPrevExA(
   CodePage: WORD;
   lpStart : LPCSTR;
   lpCurrentChar: LPCSTR;
   dwFlags : DWORD
): LPSTR; {WINAPI} callconv; external;

function CharPrevW(
  lpszStart: LPCTSTR;
  lpszCurrent: LPCTSTR
): LPTSTR; {WINAPI} callconv; external;

function CharToOem(
  lpszSrc: LPCTSTR;
  out lpszDst: LPSTR
): BOOL; {WINAPI} {BOOL32}
function CharToOemA(
   lpszSrc: LPCTSTR;
   out lpszDst: LPSTR
): BOOL; {WINAPI} callconv; external; {BOOL32}

function CharToOemBuff(
      lpszSrc: LPCTSTR;
  out lpszDst: LPSTR;
      cchDstLength: DWORD
): BOOL; {WINAPI} {callconv; external;} {BOOL32}
function CharToOemBuffA(src: LPCSTR; out dst: LPSTR; len: DWORD): BOOL; {BOOL32} callconv; external; {WINAPI}
function CharToOemBuffW(src: LPCSTR; out dst: LPSTR; len: DWORD): BOOL; {BOOL32} callconv; external; {WINAPI}
function CharToOemW(
   lpszSrc: LPCTSTR;
   out lpszDst: LPSTR
): BOOL; {WINAPI} callconv; external; {BOOL32}

function CharUpper(
  lpsz: LPTSTR
): LPTSTR {WINAPI};
function CharUpperA(
  lpsz: LPTSTR
): LPTSTR {WINAPI}; callconv; external;

function CharUpperW(
  lpsz: LPTSTR
): LPTSTR {WINAPI}; callconv; external;

function CharUpperBuff(
  {_Inout_} lpsz: LPTSTR;
  {_In_}    cchLength: DWORD
): DWORD {WINAPI}; 

function CharUpperBuffA(
  {_Inout_} lpsz: LPTSTR;
  {_In_}    cchLength: DWORD
): DWORD {WINAPI}; callconv; external;

function CharUpperBuffW(
  {_Inout_} lpsz: LPTSTR;
  {_In_}    cchLength: DWORD
): DWORD {WINAPI}; callconv; external;

function CheckMenuItem(              { is Dummy (Y) }
  hhmenu: HMENU;
  uIDCheckItem: UINT;
  uCheck: UINT
): DWORD {WINAPI}; callconv; external;

function ChildWindowFromPoint(
   hWndParent: HWND;
   aPoint: POINT
): HWND; {WINAPI} callconv; external;

function ClientToScreen(
      Wnd: HWND;
  var Point: LPPOINT
): BOOL; callconv; external;

function ClipCursor(Rect: LPRECT): BOOL; {WINAPI} callconv; external;

function CloseClipboard: BOOL; {WINAPI} callconv; external;

function CopyIcon(icon: HICON): HICON; {WINAPI} callconv; external;   { is Dummy (Y) }

function CopyRect(
  Out   lprcDst: LPRECT;
  const lprcSrc: LPRECT
): BOOL; callconv; external; 

function CountClipboardFormats: Longint; {WINAPI} callconv; external;
function CreateCursor(
        hInst   : HINSTANCE;
        xHotSpot: Longint;
        yHotSpot: Longint;
        nWidth  : Longint;
        nHeight : Longint;
  const pvANDPlane: Pointer;
  const pvXORPlane: Pointer
): HCURSOR; {WINAPI} callconv; external;


function CreateDialogParam(        { is Dummy (Y) }
   Instance: HINSTANCE;
   lpTemplateName: LPCTSTR;
   hWndParent: HWND;
   lpDialogFunc: DLGPROC;
   dwInitParam: LPARAM
): HWND; {WINAPI} {callconv; external;}

function CreateDialogParamA(        { is Dummy (Y) }
   Instance: HINSTANCE;
   lpTemplateName: LPCTSTR;
   hWndParent: HWND;
   lpDialogFunc: DLGPROC;
   dwInitParam: LPARAM
): HWND; {WINAPI} callconv; external;

function CreateIcon(                { is Dummy (Y) }
        Instance  : HINSTANCE;
        nWidth    : Longint;
        nHeight   : Longint;
        cPlanes   : BYTE;
        cBitsPixel: BYTE;
  const lpbANDbits: PBYTE;
  const lpbXORbits: PBYTE
): HICON; {WINAPI} callconv; external;

function CreateIconFromResource(    { is Dummy (Y) }
   presbits: PBYTE;
   dwResSize: DWORD;
   fIcon: BOOL;    {BOOL32}
   dwVer: DWORD
): HICON; {WINAPI} callconv; external;

function CreateIconFromResourceEx(  { is Dummy (Y) }
  pbIconBits: PBYTE;
  cbIconBits: DWORD;
  fIcon     : BOOL;    {BOOL32}
  dwVersion : DWORD;
  cxDesired : Longint;
  cyDesired : Longint;
  uFlags    : UINT
): HICON {WINAPI} callconv; external;

function CreateIconIndirect(iconinfo: PICONINFO): HICON; {WINAPI} callconv; external;   { is Dummy (Y) }

function CreateMenu: HMenu; {WINAPI} callconv; external;

function CreatePopupMenu: HMenu; {WINAPI} callconv; external;

function CreateWindowEx(
  dwExStyle: DWORD;
  lpClassName : LPCTSTR;
  lpWindowName: LPCTSTR;
  dwStyle     : DWORD;
  x           : Longint;
  y           :  Longint;
  nWidth      : Longint;
  nHeight     : Longint;
  hWndParent  : HWND;
  Menu        : HMENU;
  Instance    : HINSTANCE;
  lpParam     : Pointer
): HWND;

function CreateWindowExA(
  dwExStyle: DWORD;
  lpClassName : LPCTSTR;
  lpWindowName: LPCTSTR;
  dwStyle     : DWORD;
  x           : Longint;
  y           :  Longint;
  nWidth      : Longint;
  nHeight     : Longint;
  hWndParent  : HWND;
  Menu        : HMENU;
  Instance    : HINSTANCE;
  lpParam     : Pointer
): HWND {WINAPI} callconv; external; 

function DefWindowProc(
  Wnd: HWND;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): LRESULT;

function DefWindowProcA(
  Wnd: HWND;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): LRESULT; {WINAPI} callconv; external;


function DeleteMenu(
  Menu: HMENU;
  uPosition: UINT;
  uFlags: UINT
): BOOL; {WINAPI} callconv; external;


function DestroyCursor(cursor: HCURSOR): BOOL; {WINAPI} callconv; external;

function DestroyIcon(icon: HICON): BOOL; {WINAPI} callconv; external; { is Dummy (Y) }

function DestroyMenu(menu: HMENU): BOOL; {WINAPI} callconv; external;

function DestroyWindow(wnd: HWND): BOOL; {WINAPI} callconv; external;
function DialogBoxIndirectParamA(   { is Dummy (Y) }
  Instance: HINSTANCE;
  hDialogTemplate: LPCDLGTEMPLATE;
  hWndParent: HWND;
  lpDialogFunc: DLGPROC;
  dwInitParam: LPARAM
): INT_PTR; {WINAPI} callconv; external;

function DialogBoxParam(            { is Dummy (Y) }
  Instance: HINSTANCE;
  lpTemplateName: LPCTSTR;
  hWndParent: HWND;
  lpDialogFunc: DLGPROC;
  dwInitParam: LPARAM
): INT_PTR;

function DialogBoxParamA(           { is Dummy (Y) }
  Instance: HINSTANCE;
  lpTemplateName: LPCTSTR;
  hWndParent: HWND;
  lpDialogFunc: DLGPROC;
  dwInitParam: LPARAM
): INT_PTR; {WINAPI} callconv; external;

function DispatchMessage(const msg: LPMSG): LRESULT;
function DispatchMessageA(const msg: LPMSG): LRESULT; {WINAPI} callconv; external;

function DrawAnimatedRects(         { is Dummy (Y) }
        wnd     : HWND;
        idAni   : Longint;
  const lprcFrom: LPRECT;
  const lprcTo  : LPRECT
): BOOL; callconv; external;

function DrawFocusRect(dc: HDC; const lpRc: LPRECT): BOOL; callconv; external; { is Dummy (Y) }
function DrawIcon(                  { is Dummy (Y) }
  DC: HDC;
  X : Longint;
  Y : Longint;
  Icon: HICON
): BOOL; {WINAPI} callconv; external;

function DrawIconEx(                { is Dummy (Y) }
  dc: HDC;
  xLeft: Longint;
  yTop: Longint;
  Icon: HICON;
  cxWidth: Longint;
  cyWidth: Longint;
  istepIfAniCur: UINT;
  hbrFlickerFreeDraw: HBRUSH;
  diFlags: UINT
): BOOL;

function DrawIconExA(               { is Dummy (Y) }
  dc: HDC;
  xLeft: Longint;
  yTop: Longint;
  Icon: HICON;
  cxWidth: Longint;
  cyWidth: Longint;
  istepIfAniCur: UINT;
  hbrFlickerFreeDraw: HBRUSH;
  diFlags: UINT
): BOOL; {WINAPI} callconv; external;

function DrawMenuBar(wnd: HWND): BOOL; {WINAPI} callconv; external; { is Dummy (Y) }

function DrawText(
      DC: HDC;
  var lpchText: LPCTSTR;
      nCount: Longint;
  var Rect: LPRECT;
      uFormat: UINT
): Longint;

function DrawTextA(
      DC: HDC;
  var lpchText: LPCTSTR;
      nCount: Longint;
  var Rect: LPRECT;
      uFormat: UINT
): Longint; callconv; external;

function EmptyClipboard: BOOL; {WINAPI} callconv; external;

function EnableWindow(wnd: HWND; bEnable: BOOL): BOOL {WINAPI} callconv; external; { is Dummy (Y) }
function EndDialog(hdlg: HWND; nResult: INT_PTR): BOOL {WINAPI} callconv; external;{ is Dummy (Y) }

function EndPaint(wnd: HWND; const lpPaint: PAINTSTRUCT): BOOL; callconv; external;
function EnumClipboardFormats(format: UINT): UINT; {WINAPI} callconv; external;


function EnumDisplaySettings(
      lpszDeviceName: LPCTSTR;
      iModeNum: DWORD;
  Out DevMode: LPDEVMODE
): BOOL;

function EnumDisplaySettingsA(
      lpszDeviceName: LPCTSTR;
      iModeNum: DWORD;
  Out DevMode: LPDEVMODE
): BOOL; callconv; external;

function EnumThreadWindows(
  dwThreadId: DWORD;
  lpfn : WNDENUMPROC;
  Param: LPARAM
): BOOL; {WINAPI} callconv; external;

function EnumChildWindows(
   hWndParent: HWND;
   lpEnumFunc: WNDENUMPROC;
   Param: LPARAM      
): BOOL; {WINAPI} callconv; external;

function EnumWindows(
   lpEnumFunc: WNDENUMPROC;
   Param: LPARAM      
): BOOL; {WINAPI} callconv; external;

function ExitWindowsEx(             { is Dummy (Y) }
  uFlags: UINT;
  dwReason: DWORD
): BOOL; {WINAPI} callconv; external;

function FillRect(
         DC: HDC;
   const lprc: LPRECT;
         hbr: HBRUSH
): Longint; callconv; external;


function FindWindow(
  lpClassName: LPCTSTR;
  lpWindowName: LPCTSTR
): HWND;

function FindWindowA(
  lpClassName: LPCTSTR;
  lpWindowName: LPCTSTR
): HWND; {WINAPI} callconv; external;

function FindWindowEx(
  hwndParent    : HWND;
  hwndChildAfter: HWND;
  lpszClass     : LPCTSTR;
  lpszWindow    : LPCTSTR
): HWND; {WINAPI} 

function FindWindowExA(
  hwndParent    : HWND;
  hwndChildAfter: HWND;
  lpszClass     : LPCTSTR;
  lpszWindow    : LPCTSTR
): HWND; {WINAPI} callconv; external;

function GetActiveWindow: HWND; {WINAPI} callconv; external;
function GetAsyncKeyState(vKey: Longint): SHORT; {WINAPI} callconv; external;
function GetCapture: HWND;
function GetClassInfo(
  Instance: HINSTANCE;
  lpClassName: LPCTSTR;
  Out pWndClass: LPWNDCLASS
): BOOL;

function GetClassInfoA(
  Instance: HINSTANCE;
  lpClassName: LPCTSTR;
  Out pWndClass: LPWNDCLASS
): BOOL; {WINAPI} callconv; external;

function GetClassInfoEx(
      hinst    : HINSTANCE;
      lpszClass: LPCTSTR;
  Out lpwcx    : LPWNDCLASSEX
): BOOL;

function GetClassInfoExA(
      hinst    : HINSTANCE;
      lpszClass: LPCTSTR;
  Out lpwcx    : LPWNDCLASSEX
): BOOL; {WINAPI} callconv; external;

function GetClientRect(wnd: HWND; out Rect: LPRECT): BOOL; {WINAPI} callconv; external;
function GetClipboardData(uFormat: UINT): HANDLE; {WINAPI} callconv; external;

function GetClipboardFormatName(
      format: UINT;
  Out lpszFormatName: LPTSTR;
      cchMaxCount: Longint
): Longint; 

function GetClipboardFormatNameA(
      format: UINT;
  Out lpszFormatName: LPTSTR;
      cchMaxCount: Longint
): Longint; {WINAPI} callconv; external;

function GetClipboardOwner: HWND; {WINAPI} callconv; external;
function GetCursor: HCURSOR; {WINAPI} callconv; external;
function GetCursorPos(out Point: LPPOINT): BOOL; {WINAPI} callconv; external;
function GetDC(wnd: HWND): HDC; callconv; external;

function GetDesktopWindow: HWND; {WINAPI} callconv; external;  { is Dummy (Y) }
function GetDlgItem(                                           { is Dummy (Y) }
   hDlg: HWND;
   nIDDlgItem: Longint
): HWND; {WINAPI} callconv; external;


function GetDoubleClickTime: UINT; {WINAPI} callconv; external;
function GetFocus: HWND; {WINAPI} callconv; external;
function GetForegroundWindow: HWND; {WINAPI} callconv; external;

function GetIconInfo(               { is Dummy (Y) }
      Icon: HICON;
  Out iconinfo: PICONINFO
): BOOL; {WINAPI} callconv; external;


function GetKeyboardState(out lpKeyState: PBYTE): BOOL; {WINAPI} callconv; external;
function GetKeyboardLayout(idThread: DWORD): HKL; {WINAPI} callconv; external;

function GetKeyboardLayoutName(out pwszKLID: LPTSTR): BOOL; {WINAPI} {callconv; external;} { is Dummy (Y) }
function GetKeyboardLayoutNameA(out pwszKLID: LPTSTR): BOOL; {WINAPI} callconv; external; { is Dummy (Y) }

function GetKeyboardType(nTypeFlag: Longint): Longint; {WINAPI} callconv; external;

function GetKeyNameText(           { is Dummy (Y) }
      lParam:  LONG;
  Out lpString: LPTSTR;
      cchSize:  Longint
): Longint;

function GetKeyNameTextA(           { is Dummy (Y) }
      lParam:  LONG;
  Out lpString: LPTSTR;
      cchSize:  Longint
): Longint; {WINAPI} callconv; external;

function GetKeyState(nVirtKey: Longint): SHORT; {WINAPI} callconv; external;
function GetLastActivePopup(wnd: HWND): HWND; {WINAPI} callconv; external; { is Dummy (Y) }

function GetMenu(wnd: HWND): HMENU; { is Dummy (Y) } {WINAPI} callconv; external;
function GetMenuItemCount(menu: HMENU): Longint; {WINAPI} callconv; external; { is Dummy (Y) }

function GetMenuItemID(             { is Dummy (Y) }
  Menu: HMENU;
  nPos: Longint
): UINT; {WINAPI} callconv; external;


function GetMenuItemInfo(          { is Dummy (Y) }
      Menu: HMENU;
      uItem: UINT;
      fByPosition: BOOL;
  var lpmii: LPMENUITEMINFO
): BOOL;

function GetMenuItemInfoA(          { is Dummy (Y) }
      Menu: HMENU;
      uItem: UINT;
      fByPosition: BOOL;
  var lpmii: LPMENUITEMINFO
): BOOL; {WINAPI} callconv; external;

function GetMenuState(              { is Dummy (Y) }
  Menu: HMENU;
  uId: UINT;
  uFlags: UINT
): UINT; {WINAPI} callconv; external;

function GetMenuString(            { is Dummy (Y) }
      Menu: HMENU;
      uIDItem: UINT;
  Out lpString: LPTSTR;
      nMaxCount: Longint;
      uFlag: UINT
): Longint;

function GetMenuStringA(            { is Dummy (Y) }
      Menu: HMENU;
      uIDItem: UINT;
  Out lpString: LPTSTR;
      nMaxCount: Longint;
      uFlag: UINT
): Longint; {WINAPI} callconv; external;


function GetMessage(
  Out Msg: LPMSG;
      Wnd: HWND;
      wMsgFilterMin: UINT;
      wMsgFilterMax: UINT
): BOOL; 

function GetMessageA(
  Out Msg: LPMSG;
      Wnd: HWND;
      wMsgFilterMin: UINT;
      wMsgFilterMax: UINT
): BOOL; {WINAPI} callconv; external;

function GetMessageTime: Longint; {WINAPI} callconv; external;
function GetNextDlgTabItem(         { is Dummy (Y) }
    hDlg: HWND;
    hCtl: HWND;
    bPrevious: BOOL
): HWND; {WINAPI} callconv; external; 

function GetParent(wnd: HWND): HWND; {WINAPI} callconv; external;
function GetProcessWindowStation: HWINSTA; {WINAPI} callconv; external; { is Dummy (Y) }
function GetQueueStatus(flags: UINT): DWORD; {WINAPI} callconv; external; { is Dummy (Y) }

function GetSubMenu(                { is Dummy (Y) }
  Menu: HMENU;
  nPos: Longint
): HMENU; {WINAPI} callconv; external;

function GetSysColor(nIndex: Longint): DWORD; {WINAPI} callconv; external; { is Dummy (Y) }

function GetSysColorBrush(nIndex: Longint): HBRUSH; callconv; external;
function GetSystemMenu(
  Wnd: HWND; 
  bRevert: BOOL
): HMENU; {WINAPI} callconv; external;
function GetSystemMetrics(nIndex: Longint): Longint; {WINAPI} callconv; external;

function GetThreadDesktop(dwThreadId: DWORD): HDESK; {WINAPI} callconv; external; { is Dummy (Y) }

function GetTitleBarInfo(           { is Dummy (Y) }
      wnd: HWND;
  var pti: PTITLEBARINFO
): BOOL; {WINAPI} callconv; external;

function GetTopWindow(wnd: HWND): HWND; {WINAPI} callconv; external; { is Dummy (Y) }
function GetUpdateRgn(
  Wnd: HWND;
  Rgn: HRGN;
  bErase: BOOL
): Longint; callconv; external;

function GetUserObjectInformation( { is Dummy (Y) }
      hObj: HANDLE;
      nIndex: Longint;
  out pvInfo: PVOID;
      nLength: DWORD;
  out lpnLengthNeeded: LPDWORD
): BOOL;

function GetUserObjectInformationW( { is Dummy (Y) }
      hObj: HANDLE;
      nIndex: Longint;
  out pvInfo: PVOID;
      nLength: DWORD;
  out lpnLengthNeeded: LPDWORD
): BOOL; {WINAPI} callconv; external;

function GetWindow(                 { is Dummy (Y) }
  Wnd: HWND;
  uCmd: UINT
): HWND; {WINAPI} callconv; external;

function GetWindowDC(Wnd: HWND): HDC; callconv; external;
function GetWindowLong(
  Wnd: HWND;
  nIndex: Longint
): Long;
function GetWindowLongA(
  Wnd: HWND;
  nIndex: Longint
): Long; {WINAPI} callconv; external;

function GetWindowPlacement(
      Wnd: HWND;
  var lpwndpl: LPWINDOWPLACEMENT
): BOOL; {WINAPI} callconv; external;

function GetWindowRect(
      Wnd : HWND;
  out Rect: LPRECT
): BOOL; {WINAPI} callconv; external;

function GetWindowRgn(Wnd: HWND; hRgn: HRGN): Longint; callconv; external;

function GetWindowText(
      Wnd: HWND;
  out lpString: LPTSTR;
      nMaxCount: Longint
): Longint;

function GetWindowTextA(
      Wnd: HWND;
  out lpString: LPTSTR;
      nMaxCount: Longint
): Longint; {WINAPI} callconv; external;

function GetWindowTextLength(Wnd: HWND): Longint;
function GetWindowTextLengthA(Wnd: HWND): Longint; callconv; external;
function GetWindowThreadProcessId(
      Wnd: HWND;
  Out lpdwProcessId: LPDWORD
): DWORD; {WINAPI} callconv; external;


function GrayString(                { is Dummy (Y) }
   DC: HDC;
   Brush: HBRUSH;
   lpOutputFunc: GRAYSTRINGPROC;
   lpData: LPARAM;
   nCount: Longint;
   X: Longint;
   Y: Longint;
   nWidth: Longint;
   nHeight: Longint
): BOOL;

function GrayStringA(               { is Dummy (Y) }
   DC: HDC;
   Brush: HBRUSH;
   lpOutputFunc: GRAYSTRINGPROC;
   lpData: LPARAM;
   nCount: Longint;
   X: Longint;
   Y: Longint;
   nWidth: Longint;
   nHeight: Longint
): BOOL; callconv; external;

function InflateRect(
  var lprc: LPRECT;
      dx: Longint;
      dy: Longint
): BOOL; callconv; external;

function InSendMessage: BOOL; {WINAPI} callconv; external; { is Dummy (Y) }

function InsertMenu(
  Menu: HMENU;
  uPosition: UINT;
  uFlags: UINT;
  uIDNewItem: UINT_PTR;
  lpNewItem: LPCTSTR
): BOOL;

function InsertMenuA(
  Menu: HMENU;
  uPosition: UINT;
  uFlags: UINT;
  uIDNewItem: UINT_PTR;
  lpNewItem: LPCTSTR
): BOOL; {WINAPI} callconv; external;

function IntersectRect(
  Out   lprcDst : LPRECT;
  const lprcSrc1: LPRECT;
  const lprcSrc2: LPRECT
): Bool; callconv; external;

function InvalidateRect(
        Wnd: HWND;
  const Rect: LPRECT;
        bErase: BOOL
): BOOL; callconv; external;

function IsCharAlpha(ch: TCHAR): BOOL;
function IsCharAlphaA(ch: TCHAR): BOOL; {WINAPI} callconv; external;
function IsCharAlphaW(ch: TCHAR): BOOL; {WINAPI} callconv; external;
function IsCharAlphaNumeric(ch: TCHAR): BOOL;
function IsCharAlphaNumericA(ch: TCHAR): BOOL; {WINAPI} callconv; external;
function IsCharAlphaNumericW(ch: TCHAR): BOOL; {WINAPI} callconv; external;
function IsCharLowerA(ch: TCHAR): BOOL; {WINAPI} callconv; external;

function IsCharLower(ch: TCHAR): BOOL;
function IsCharLowerW(ch: TCHAR): BOOL; {WINAPI} callconv; external;
function IsCharUpper(ch: TCHAR): BOOL;
function IsCharUpperA(ch: TCHAR): BOOL; {WINAPI} callconv; external;
function IsCharUpperW(ch: TCHAR): BOOL; {WINAPI} callconv; external;
function IsClipboardFormatAvailable(format: UINT): BOOL; {WINAPI} callconv; external;
function IsDlgButtonChecked(
  hDlg: HWND;
  nIDButton: Longint
): UINT; callconv; external;


function IsDialogMessage(
  hDlg: HWND;
  Msg : LPMSG
): BOOL; 

function IsDialogMessageA(
  hDlg: HWND;
  Msg : LPMSG
): BOOL; {WINAPI} callconv; external;

function IsIconic(Wnd: HWND): BOOL; {WINAPI} callconv; external;
function IsRectEmpty(const lpRc: LPRECT): BOOL; callconv; external;
function IsWindow(Wnd: HWND): BOOL; {WINAPI} callconv; external;
function IsZoomed(Wnd: HWND): BOOL; {WINAPI} callconv; external;

function KillTimer(
  Wnd: HWND;
  uIDEvent: UINT_PTR
):BOOL; {WINAPI} callconv; external;

function LoadBitmap(
  Instance: HINSTANCE;
  lpBitmapName: LPCTSTR
): HBITMAP;

function LoadBitmapA(
  Instance: HINSTANCE;
  lpBitmapName: LPCTSTR
): HBITMAP; callconv; external;

function LoadCursor(
  Instance: HINSTANCE;
  lpCursorName: LPCTSTR
): HCURSOR;

function LoadCursorA(
  Instance: HINSTANCE;
  lpCursorName: LPCTSTR
): HCURSOR; {WINAPI} callconv; external;

function LoadIcon(
  Instance  : HINSTANCE;
  lpIconName: LPCTSTR
): HICON;

function LoadIconA(
  Instance  : HINSTANCE;
  lpIconName: LPCTSTR
): HICON; {WINAPI} callconv; external;

function LoadImage(
  hinst: HINSTANCE;
  lpszName: LPCTSTR;
  uType: UINT;
  cxDesired: Longint;
  cyDesired: Longint;
  fuLoad: UINT
): HANDLE;

function LoadImageA(
  hinst: HINSTANCE;
  lpszName: LPCTSTR;
  uType: UINT;
  cxDesired: Longint;
  cyDesired: Longint;
  fuLoad: UINT
): HANDLE; {WINAPI} callconv; external;

function LoadKeyboardLayout(
  pwszKLID: LPCTSTR;
  Flags: UINT
): HKL;

function LoadKeyboardLayoutA(
  pwszKLID: LPCTSTR;
  Flags: UINT
): HKL; {WINAPI} callconv; external;

function LoadMenu(                 { is Dummy (Y) }
  Instance: HINSTANCE;
  lpMenuName: LPCTSTR
): HMENU;

function LoadMenuA(                 { is Dummy (Y) }
  Instance: HINSTANCE;
  lpMenuName: LPCTSTR
): HMENU; {WINAPI} callconv; external;

function LoadString(
  Instance: HINSTANCE;
  uID: UINT;
  lpBuffer: LPTSTR;
  nBufferMax: Longint
): Longint;

function LoadStringA(
  Instance: HINSTANCE;
  uID: UINT;
  lpBuffer: LPTSTR;
  nBufferMax: Longint
): Longint; {WINAPI} callconv; external;

function LoadStringW(
  Instance: HINSTANCE;
  uID: UINT;
  lpBuffer: LPTSTR;
  nBufferMax: Longint
): Longint; {WINAPI} callconv; external;

function MapVirtualKey(
  uCode: UINT;
  uMapType: UINT
): UINT;

function MapVirtualKeyA(
  uCode: UINT;
  uMapType: UINT
): UINT; {WINAPI} callconv; external;

function MapVirtualKeyEx(
  uCode: UINT;
  uMapType: UINT;
  var dwhkl: HKL
): UINT;

function MapVirtualKeyExA(
  uCode: UINT;
  uMapType: UINT;
  var dwhkl: HKL
): UINT; {WINAPI} callconv; external;

function MapWindowPoints(
  hWndFrom: HWND;
  hWndTo: HWND;
  var lpPoints: LPPOINT;
  cPoints: UINT
): Longint; callconv; external;

function MessageBeep(uType: UINT): BOOL; {WINAPI} callconv; external;
function MessageBox(
  Wnd: HWND;
  lpText: LPCTSTR;
  lpCaption: LPCTSTR;
  uType: UINT
): Longint;
function MessageBoxA(
  Wnd: HWND;
  lpText: LPCTSTR;
  lpCaption: LPCTSTR;
  uType: UINT
): Longint; {WINAPI} callconv; external;

function MessageBoxExA(
  Wnd: HWND;
  lpText: LPCTSTR;
  lpCaption: LPCTSTR;
  uType: UINT;
  wLanguageId: WORD
): Longint; {WINAPI} callconv; external;

function MessageBoxIndirect(const MsgBoxParams: LPMSGBOXPARAMS): Longint;
function MessageBoxIndirectA(const MsgBoxParams: LPMSGBOXPARAMS): Longint; {WINAPI} callconv; external;
function MessageBoxW(
  Wnd: HWND;
  lpText: LPCTSTR;
  lpCaption: LPCTSTR;
  uType: UINT
): Longint; {WINAPI} callconv; external;
function ModifyMenu(               { is Dummy (Y) }
  hMnu: HMENU;
  uPosition: UINT;
  uFlags: UINT;
  uIDNewItem: UINT_PTR;
  lpNewItem: LPCTSTR
): BOOL;
function ModifyMenuA(               { is Dummy (Y) }
  hMnu: HMENU;
  uPosition: UINT;
  uFlags: UINT;
  uIDNewItem: UINT_PTR;
  lpNewItem: LPCTSTR
): BOOL; {WINAPI} callconv; external;

function MoveWindow(
  Wnd: HWND;
  X: Longint;
  Y: Longint;
  nWidth: Longint;
  nHeight: Longint;
  bRepaint: BOOL
): BOOL; {WINAPI} callconv; external;

function MsgWaitForMultipleObjects(
        nCount: DWORD;
  const pHandles: Pointer{array of HANDLE};
        bWaitAll: BOOL;
        dwMilliseconds: DWORD;
        dwWakeMask: DWORD
): DWORD; {WINAPI} callconv; external;

function OemToChar(
      lpszSrc: LPCSTR;
  Out lpszDst: LPTSTR
): BOOL;

function OemToCharA(
      lpszSrc: LPCSTR;
  Out lpszDst: LPTSTR
): BOOL; {WINAPI} callconv; external;

function OemToCharBuff(
      lpszSrc: LPCSTR;
  Out lpszDst: LPTSTR;
      cchDstLength: DWORD
): BOOL;

function OemToCharBuffA(
      lpszSrc: LPCSTR;
  Out lpszDst: LPTSTR;
      cchDstLength: DWORD
): BOOL; {WINAPI} callconv; external;

function OemToCharBuffW(
      lpszSrc: LPCSTR;
  Out lpszDst: LPTSTR;
      cchDstLength: DWORD
): BOOL; {WINAPI} callconv; external;

function OemToCharW(
      lpszSrc: LPCSTR;
  Out lpszDst: LPTSTR
): BOOL; {WINAPI} callconv; external;

function OffsetRect(
  var lprc: LPRECT;
      dx: Longint;
      dy: Longint
): BOOL; callconv; external;

function OpenClipboard(hWndNewOwner: HWND): BOOL; {WINAPI} callconv; external;
function OpenIcon(Wnd: HWND): BOOL; {WINAPI} callconv; external;

function PeekMessage(
  Out Msg: LPMSG;
      Wnd: HWND;
      wMsgFilterMin: UINT;
      wMsgFilterMax: UINT;
      wRemoveMsg: UINT
): BOOL;

function PeekMessageA(
  Out Msg: LPMSG;
      Wnd: HWND;
      wMsgFilterMin: UINT;
      wMsgFilterMax: UINT;
      wRemoveMsg: UINT
): BOOL; {WINAPI} callconv; external;

function PostMessage(
  Wnd: HWND;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): BOOL;

function PostMessageA(
  Wnd: HWND;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): BOOL; {WINAPI} callconv; external;

procedure PostQuitMessage(nExitCode: Longint); callconv; external;

function PostThreadMessage(
  idThread: DWORD;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): BOOL;

function PostThreadMessageA(
  idThread: DWORD;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): BOOL; {WINAPI} callconv; external;

function PtInRect(const lprc: LPRECT; pt: POINT): BOOL; callconv; external;
function RegisterClass(const wndClass: LPWNDCLASS): ATOM; 
function RegisterClassA(const wndClass: LPWNDCLASS): ATOM; {WINAPI} callconv; external;
function RegisterClassEx(lpwcx: LPWNDCLASSEX): ATOM;
function RegisterClassExA(lpwcx: LPWNDCLASSEX): ATOM; {WINAPI} callconv; external;
function RegisterClipboardFormat(lpszFormat: LPCTSTR): UINT;
function RegisterClipboardFormatA(lpszFormat: LPCTSTR): UINT; {WINAPI} callconv; external;

function RegisterHotKey(
  Wnd: HWND;
  id: Longint;
  fsModifiers: UINT;
  vk: UINT
): BOOL; {WINAPI} callconv; external;

function RegisterWindowMessage(lpString: LPCTSTR): UINT;
function RegisterWindowMessageA(lpString: LPCTSTR): UINT; {WINAPI} callconv; external; { is Dummy (Y) }
function ReleaseCapture: BOOL;
function ReleaseDC(Wnd: HWND; dc: HDC): Longint; callconv; external;
function RemoveMenu(                { is Dummy (Y) }
  Menu: HMENU;
  uPosition: UINT;
  uFlags: UINT
): BOOL; {WINAPI} callconv; external;

function ScreenToClient(Wnd: HWND; Point: LPPOINT): BOOL; callconv; external;

function ScrollWindowEx(            { is Dummy (Y) }
          Wnd: HWND;
          dx: Longint;
          dy: Longint;
    const prcScroll: LPRECT;
    const prcClip: LPRECT;
          hrgnUpdate: HRGN;
        out   prcUpdate: LPRECT;
          flags: UINT
): Longint; callconv; external;

function SendDlgItemMessage(
  hDlg: HWND;
  nIDDlgItem: Longint;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): LRESULT;

function SendDlgItemMessageA(
  hDlg: HWND;
  nIDDlgItem: Longint;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): LRESULT; {WINAPI} callconv; external;

function SendMessage(
  Wnd: HWND;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): LRESULT;

function SendMessageA(
  Wnd: HWND;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): LRESULT; {WINAPI} callconv; external;

function SendMessageW(
  Wnd: HWND;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): LRESULT; {WINAPI} callconv; external;

function SetActiveWindow(Wnd: HWND): HWND; {WINAPI} callconv; external;

function SetCapture(wnd: HWND): HWND;

function SetClassLong(
  Wnd: HWND;
  nIndex: Longint;
  dwNewLong: LONG
): DWORD;

function SetClassLongA(
  Wnd: HWND;
  nIndex: Longint;
  dwNewLong: LONG
): DWORD; {WINAPI} callconv; external;

function SetClipboardData(
  uFormat: UINT;
  hMem: HANDLE
): HANDLE; {WINAPI} callconv; external;

function SetClipboardViewer(hWndNewViewer: HWND): HWND; {WINAPI} callconv; external; { is Dummy (Y) }
function SetCursorPos(
  X: Longint;
  Y: Longint
): BOOL; {WINAPI} callconv; external;

function SetCursor(Cursor: HCURSOR): HCURSOR; {WINAPI} callconv; external;

function SetDlgItemText(           { is Dummy (Y) }
  hDlg: HWND;
  nIDDlgItem: Longint;
  lpString: LPCTSTR
): BOOL;

function SetDlgItemTextA(           { is Dummy (Y) }
  hDlg: HWND;
  nIDDlgItem: Longint;
  lpString: LPCTSTR
): BOOL; {WINAPI} callconv; external;

function SetFocus(Wnd: HWND): HWND; {WINAPI} callconv; external;
function SetForegroundWindow(Wnd: HWND): BOOL; {WINAPI} callconv; external; { is Dummy (Y) }
function SetKeyboardState(lpKeyState: LPBYTE): BOOL; {WINAPI} callconv; external;  { is Dummy (Y) }
function SetMenuDefaultItem(        { is Dummy (Y) }
  Menu  : HMENU;
  uItem : UINT;
  fByPos: UINT
): BOOL; {WINAPI} callconv; external;

function SetMenuItemInfo(          { is Dummy (Y) }
  Menu: HMENU;
  uItem: UINT;
  fByPosition: BOOL;
  lpmii: LPMENUITEMINFO
): BOOL;

function SetMenuItemInfoA(          { is Dummy (Y) }
  Menu: HMENU;
  uItem: UINT;
  fByPosition: BOOL;
  lpmii: LPMENUITEMINFO
): BOOL; {WINAPI} callconv; external;

function SetParent(
  hWndChild: HWND;
  hWndNewParent: HWND
): HWND; {WINAPI} callconv; external;

function SetRect(
  Out lprc: LPRECT;
  xLeft   :  Longint;
  yTop    :  Longint;
  xRight  :  Longint;
  yBottom :  Longint
): BOOL; callconv; external;

function SetRectEmpty(out lprc: LPRECT): BOOL; callconv; external;
function SetTimer(
  Wnd        : HWND;
  nIDEvent   : UINT_PTR;
  uElapse    : UINT;
  lpTimerFunc: TIMERPROC
): UINT_PTR; {WINAPI} callconv; external;

function SetWindowsHookEx(          { is Dummy (Y) }
  idHook: Longint;
  lpfn: HOOKPROC;
  hMod: HINSTANCE;
  dwThreadId: DWORD
): HHOOK;

function SetWindowsHookExA(         { is Dummy (Y) }
  idHook: Longint;
  lpfn: HOOKPROC;
  hMod: HINSTANCE;
  dwThreadId: DWORD
): HHOOK; {WINAPI} callconv; external;

function SetWindowLong(
  Wnd: HWND;
  nIndex: Longint;
  dwNewLong: LONG
): LONG;

function SetWindowLongA(
  Wnd: HWND;
  nIndex: Longint;
  dwNewLong: LONG
): LONG; {WINAPI} callconv; external;

function SetWindowPlacement(
        Wnd: HWND;
  const lpwndpl: LPWINDOWPLACEMENT
): LONG; {WINAPI} callconv; external;

function SetWindowPos(
  Wnd: HWND;
  hWndInsertAfter: HWND;
  X: Longint;
  Y: Longint;
  cx: Longint;
  cy: Longint;
  uFlags: UINT
): BOOL; {WINAPI} callconv; external;

function SetWindowRgn(
  hWnd: HWND;
  hRgn: HRGN;
  bRedraw: BOOL
): Longint; callconv; external;

function SetWindowText(Wnd: HWND; lpString: LPCTSTR): BOOL;
function SetWindowTextA(Wnd: HWND; lpString: LPCTSTR): BOOL; {WINAPI} callconv; external;

function SetWindowTextW(Wnd: HWND; lpString: LPCTSTR): BOOL; {WINAPI} callconv; external;
function SetSysColors(              { is Dummy (Y) }
        cElements: Longint;
  const lpaElements: LPINT;   {LPINTEGER}  
  const lpaRgbValues: LPCOLORREF
): BOOL; {WINAPI} callconv; external;


function ShowCursor(bShow: BOOL): Longint; {WINAPI} callconv; external;
function ShowOwnedPopups(           { is Dummy (Y) }
  Wnd: HWND;
  fShow: BOOL
): BOOL; {WINAPI} callconv; external;

function ShowWindow(wnd: HWND; nCmdShow: Longint): BOOL; callconv; external;

function SystemParametersInfo(      { is Dummy (Y) }
      uiAction: UINT;
      uiParam : UINT;
  var pvParam : PVOID;
      fWinIni : UINT
): BOOL;

function SystemParametersInfoA(     { is Dummy (Y) }
      uiAction: UINT;
      uiParam : UINT;
  var pvParam : PVOID;
      fWinIni : UINT
): BOOL; {WINAPI} callconv; external;

function TabbedTextOut(
        DC: HDC;
        X: Longint;
        Y: Longint;
        lpString: LPCTSTR;
        nCount: Longint;
        nTabPositions: Longint;
  const lpnTabStopPositions: LPINT;
        nTabOrigin: Longint
): LONG; callconv; external;

function ToAscii(
        uVirtKey: UINT;
        uScanCode: UINT;
  const lpKeyState: LPBYTE;
  Out   lpChar: LPWORD;
        uFlags: UINT
): Longint; {WINAPI} callconv; external;

function ToAsciiEx(
        uVirtKey: UINT;
        uScanCode: UINT;
  const lpKeyState: LPBYTE;
  Out   lpChar: LPWORD;
        uFlags: UINT;
        dwhkl: HKL
): Longint; {WINAPI} callconv; external;

function ToUnicode(
        wVirtKey: UINT;
        wScanCode: UINT;
  const lpKeyState: LPBYTE;
  Out   pwszBuff: LPWSTR;
        cchBuff: Longint;
        wFlags: UINT
): Longint; {WINAPI} callconv; external;

function TrackPopupMenu(            { is Dummy (Y) }
        Menu: HMENU;
        uFlags: UINT;
        x: Longint;
        y: Longint;
        nReserved: Longint;
        Wnd: HWND;
  const prcRect: LPRECT
): BOOL; {WINAPI} callconv; external;

function TranslateMessage(const MSG: LPMSG): BOOL; {WINAPI} callconv; external; { is Dummy (Y) }
function UnhookWindowsHookEx(hhk: HHOOK): BOOL; {WINAPI} callconv; external; { is Dummy (Y) }

function UnionRect(
  Out   lprcDst: LPRECT;
  const lprcSrc1: LPRECT;
  const lprcSrc2: LPRECT
): BOOL; {WINAPI} callconv; external;


function UnregisterClass(
   lpClassName: LPCTSTR;
   Instance: HINSTANCE
): BOOL;

function UnregisterClassA(
   lpClassName: LPCTSTR;
   Instance: HINSTANCE
): BOOL; {WINAPI} callconv; external;

function UnregisterHotKey(
  Wnd: HWND;
  id: Longint
): BOOL; {WINAPI} callconv; external;

function UpdateWindow(wnd: HWND): BOOL; callconv; external;

function ValidateRect(
        Wnd: HWND;
  const Rect: LPRECT
): BOOL; callconv; external;

function VkKeyScan(ch: TCHAR): SHORT;
function VkKeyScanA(ch: TCHAR): SHORT; callconv; external; { is Dummy (Y) }
function WaitForInputIdle(         { is Dummy (Y) }
  hProcess: HANDLE;
  dwMilliseconds: DWORD
): DWORD; {WINAPI} callconv; external;

function WindowFromDC(dc: HDC): HWND; callconv; external;
function WindowFromPoint(pt: POINT): HWND; {WINAPI} callconv; external;


function WinHelp(                  { is Dummy (Y) }
  hWndMain: HWND;
  lpszHelp: LPCTSTR;
  uCommand: UINT;
  dwData: ULONG_PTR
): BOOL;
function WinHelpA(                  { is Dummy (Y) }
  hWndMain: HWND;
  lpszHelp: LPCTSTR;
  uCommand: UINT;
  dwData: ULONG_PTR
): BOOL; callconv; external;

function wsprintf(
  Out lpOut: LPTSTR;
      lpFmt: LPCTSTR;
  {_In_          ...} s: array of String
): Longint;

function wsprintfA(
  Out lpOut: LPTSTR;
      lpFmt: LPCTSTR;
  {_In_          ...} s: array of String
): Longint; {__cdecl} callconv; external;

function wvsprintf(
  out lpOutput: LPTSTR;
      lpFmt: LPCTSTR;
      arglist: va_list
): Longint;
function wvsprintfA(
  out lpOutput: LPTSTR;
      lpFmt: LPCTSTR;
      arglist: va_list
): Longint; callconv; external;





implementation

{$undef read_interface}
{$define read_implementation}
{$i gdi_base.inc}
{$i gdi_struct.inc}
{$i gdi_msg.inc}



function CharLower(lpsz: LPTSTR): LPTSTR;
begin
  CharLower := CharLowerA(lpsz);
end;

function CharLowerBuff(
  lpsz: LPTSTR;
  cchLength: DWORD
): DWORD; {WINAPI} 
begin
  CharLowerBuff := CharLowerBuffA(lpsz, cchLength);
end;

function CharNext(lpsz: LPCTSTR): LPTSTR;
begin
  CharNext := CharNextA(lpsz);
end;

function CharToOem(
  lpszSrc: LPCTSTR;
 out lpszDst: LPSTR
): BOOL; {WINAPI} {BOOL32}
begin
  CharToOem := CharToOemA(lpszSrc, lpszDst);
end;

function CharToOemBuff(
      lpszSrc: LPCTSTR;
  out lpszDst: LPSTR;
      cchDstLength: DWORD
): BOOL; 
begin
  CharToOemBuff := CharToOemBuffA(lpszSrc, lpszDst, cchDstLength);
end;

function CharUpper(lpsz: LPTSTR): LPTSTR;
begin
  CharUpper := CharUpperW(lpsz);
end;

function CharUpperBuff(
  {_Inout_} lpsz: LPTSTR;
  {_In_}    cchLength: DWORD
): DWORD {WINAPI}; 
begin
  CharUpperBuff := CharUpperBuffA(lpsz, cchLength);
end;

function CreateDialogParam(         { is Dummy (Y) }
   Instance: HINSTANCE;
   lpTemplateName: LPCTSTR;
   hWndParent: HWND;
   lpDialogFunc: DLGPROC;
   dwInitParam: LPARAM
): HWND; {WINAPI} 
begin
  CreateDialogParam := CreateDialogParamA(Instance, lpTemplateName, hWndParent, lpDialogFunc, dwInitParam);
end;


function CreateWindowEx(
  dwExStyle: DWORD;
  lpClassName : LPCTSTR;
  lpWindowName: LPCTSTR;
  dwStyle     : DWORD;
  x           : Longint;
  y           :  Longint;
  nWidth      : Longint;
  nHeight     : Longint;
  hWndParent  : HWND;
  Menu        : HMENU;
  Instance    : HINSTANCE;
  lpParam     : Pointer
): HWND;
begin
  CreateWindowEx := CreateWindowExA(dwExStyle,lpClassName,lpWindowName,dwStyle,x,y,nWidth,nHeight,hWndParent,Menu,Instance,lpParam);
end;

function DefWindowProc(
  Wnd: HWND;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): LRESULT;
begin
  DefWindowProc := DefWindowProcA(Wnd,Msg,wwParam,llParam);
end;

function DialogBoxParam(            { is Dummy (Y) }
  Instance: HINSTANCE;
  lpTemplateName: LPCTSTR;
  hWndParent: HWND;
  lpDialogFunc: DLGPROC;
  dwInitParam: LPARAM
): INT_PTR;
begin
  DialogBoxParam := DialogBoxParamA(Instance, lpTemplateName, hwndParent,lpDialogFunc,dwInitParam);
end;

function DispatchMessage(const msg: LPMSG): LRESULT;
begin
  DispatchMessage := DispatchMessageA(msg);
end;

function DrawIconEx(                { is Dummy (Y) }
  dc: HDC;
  xLeft: Longint;
  yTop: Longint;
  Icon: HICON;
  cxWidth: Longint;
  cyWidth: Longint;
  istepIfAniCur: UINT;
  hbrFlickerFreeDraw: HBRUSH;
  diFlags: UINT
): BOOL;
begin
  DrawIconEx := DrawIconExA(dc,xLeft,YTop,Icon,cxWidth,cyWidth,istepIfAniCur,hbrFlickerFreeDraw,diFlags);
end;

function DrawText(
      DC: HDC;
  var lpchText: LPCTSTR;
      nCount: Longint;
  var Rect: LPRECT;
      uFormat: UINT
): Longint;
begin
  DrawText := DrawText(dc,lpchText,nCount,Rect,uFormat);
end;

function EnumDisplaySettings(
      lpszDeviceName: LPCTSTR;
      iModeNum: DWORD;
  Out DevMode: LPDEVMODE
): BOOL;
begin
  EnumDisplaySettings := EnumDisplaySettingsA(lpszDeviceName,iModeNum,DevMode);
end;

function FindWindow(
  lpClassName: LPCTSTR;
  lpWindowName: LPCTSTR
): HWND;
begin
  FindWindow := FindWindowA(lpClassName, lpWindowName);
end;

function FindWindowEx(
  hwndParent    : HWND;
  hwndChildAfter: HWND;
  lpszClass     : LPCTSTR;
  lpszWindow    : LPCTSTR
): HWND; {WINAPI} 
begin
  FindWindowEx := FindWindowExA(hwndParent,hwndChildAfter,lpszClass,lpszWindow);
end;

function GetClassInfo(
  Instance: HINSTANCE;
  lpClassName: LPCTSTR;
  Out pWndClass: LPWNDCLASS
): BOOL;
begin
  GetClassInfo := GetClassInfoA(Instance, lpClassName, pWndClass);
end;

function GetClassInfoEx(
      hinst    : HINSTANCE;
      lpszClass: LPCTSTR;
  Out lpwcx    : LPWNDCLASSEX
): BOOL;
begin
  GetClassInfoEx := GetClassInfoExA(hinst,lpszClass,lpwcx);
end;

function GetClipboardFormatName(
      format: UINT;
  Out lpszFormatName: LPTSTR;
      cchMaxCount: Longint
): Longint; 
begin
  GetClipboardFormatName := GetClipboardFormatNameA(format,lpszFormatName,cchMaxCount);
end;

function GetKeyboardLayoutName(out pwszKLID: LPTSTR): BOOL; {WINAPI} {callconv; external;} { is Dummy (Y) }
begin
  GetKeyboardLayoutName := GetKeyboardLayoutNameA(pwszKLID);
end;

function GetKeyNameText(           { is Dummy (Y) }
      lParam:  LONG;
  Out lpString: LPTSTR;
      cchSize:  Longint
): Longint;
begin
  GetKeyNameText := GetKeyNameTextA(lParam, lpString, cchSize);
end;

function GetMenuItemInfo(          { is Dummy (Y) }
      Menu: HMENU;
      uItem: UINT;
      fByPosition: BOOL;
  var lpmii: LPMENUITEMINFO
): BOOL;
begin
  GetMenuItemInfo := GetMenuItemInfoA(Menu, uItem, fByPosition, lpmii);
end;

function GetMenuString(            { is Dummy (Y) }
      Menu: HMENU;
      uIDItem: UINT;
  Out lpString: LPTSTR;
      nMaxCount: Longint;
      uFlag: UINT
): Longint;
begin
  GetMenuString := GetMenuStringA(Menu, uIDItem, lpString, nMaxCount, uFlag);
end;

function GetMessage(
  Out Msg: LPMSG;
      Wnd: HWND;
      wMsgFilterMin: UINT;
      wMsgFilterMax: UINT
): BOOL;
begin
  GetMessage := GetMessageA(Msg, Wnd, wMsgFilterMin, wMsgFilterMax);
end;

function GetUserObjectInformation( { is Dummy (Y) }
      hObj: HANDLE;
      nIndex: Longint;
  out pvInfo: PVOID;
      nLength: DWORD;
  out lpnLengthNeeded: LPDWORD
): BOOL;
begin
  GetUserObjectInformation := GetUserObjectInformationW(hObj,nIndex,pvInfo,nLength,lpnLengthNeeded);
end;

function GetWindowLong(
  Wnd: HWND;
  nIndex: Longint
): Long;
begin
  GetWindowLong := GetWindowLongA(Wnd, nIndex);
end;

function GetWindowText(
      Wnd: HWND;
  out lpString: LPTSTR;
      nMaxCount: Longint
): Longint;
begin
  GetWindowText := GetWindowTextA(Wnd, lpString, nMaxCount);
end;

function GetWindowTextLength(Wnd: HWND): Longint;
begin
  GetWindowTextLength := GetWindowTextLengthA(wnd);
end;

function GrayString(                { is Dummy (Y) }
   DC: HDC;
   Brush: HBRUSH;
   lpOutputFunc: GRAYSTRINGPROC;
   lpData: LPARAM;
   nCount: Longint;
   X: Longint;
   Y: Longint;
   nWidth: Longint;
   nHeight: Longint
): BOOL;
begin
  GrayString := GrayStringA(DC,Brush,lpOutputFunc,lpData,nCount,X,Y,nWidth,nHeight);
end;

function InsertMenu(
  Menu: HMENU;
  uPosition: UINT;
  uFlags: UINT;
  uIDNewItem: UINT_PTR;
  lpNewItem: LPCTSTR
): BOOL;
begin
  InsertMenu := InsertMenuA(Menu, uPosition, uFlags, uIDNewItem, lpNewItem);
end;

function IsCharAlpha(ch: TCHAR): BOOL;
begin
  IsCharAlpha := IsCharAlphaA(ch);
end;

function IsCharAlphaNumeric(ch: TCHAR): BOOL;
begin
  IsCharAlphaNumeric := IsCharAlphaNumericA(ch);
end;

function IsCharLower(ch: TCHAR): BOOL;
begin
  IsCharLower := IsCharLowerA(ch);
end;

function IsCharUpper(ch: TCHAR): BOOL;
begin
  IsCharUpper := IsCharUpperA(ch);
end;

function IsDialogMessage(
  hDlg: HWND;
  Msg : LPMSG
): BOOL; 
begin
  IsDialogMessage := IsDialogMessageA(hDlg, Msg);
end;

function LoadBitmap(
  Instance: HINSTANCE;
  lpBitmapName: LPCTSTR
): HBITMAP;
begin
  LoadBitmap := LoadBitmapA(Instance,lpBitmapName);
end;

function LoadCursor(
  Instance: HINSTANCE;
  lpCursorName: LPCTSTR
): HCURSOR;
begin
  LoadCursor := LoadCursorA(Instance,lpCursorName);
end;

function LoadIcon(
  Instance  : HINSTANCE;
  lpIconName: LPCTSTR
): HICON;
begin
  LoadIcon := LoadIconA(Instance, lpIconName);
end;

function LoadImage(
  hinst: HINSTANCE;
  lpszName: LPCTSTR;
  uType: UINT;
  cxDesired: Longint;
  cyDesired: Longint;
  fuLoad: UINT
): HANDLE;
begin
  LoadImage := LoadImageA(hinst,lpszName,uType,cxDesired,cyDesired,fuLoad);
end;

function LoadKeyboardLayout(
  pwszKLID: LPCTSTR;
  Flags: UINT
): HKL;
begin
  LoadKeyboardLayout := LoadKeyboardLayoutA(pwszKLID, Flags);
end;

function LoadMenu(                 { is Dummy (Y) }
  Instance: HINSTANCE;
  lpMenuName: LPCTSTR
): HMENU;
begin
  LoadMenu := LoadMenuA(Instance, lpMenuName);
end;

function MapVirtualKey(
  uCode: UINT;
  uMapType: UINT
): UINT;
begin
  MapVirtualKey := MapVirtualKeyA(uCode, uMapType);
end;

function MapVirtualKeyEx(
  uCode: UINT;
  uMapType: UINT;
  var dwhkl: HKL
): UINT;
begin
  MapVirtualKeyEx := MapVirtualKeyExA(uCode, uMapType, dwhkl);
end;

function MessageBox(
  Wnd: HWND;
  lpText: LPCTSTR;
  lpCaption: LPCTSTR;
  uType: UINT
): Longint;
begin
  MessageBox := MessageBoxA(Wnd,lpText,lpCaption,uType);
end;

function MessageBoxEx(
  Wnd: HWND;
  lpText: LPCTSTR;
  lpCaption: LPCTSTR;
  uType: UINT;
  wLanguageId: WORD
): Longint;
begin
  MessageBoxEx := MessageBoxExA(Wnd,lpText,lpCaption,uType,wLanguageId);
end;

function MessageBoxIndirect(const MsgBoxParams: LPMSGBOXPARAMS): Longint;
begin
  MessageBoxIndirect := MessageBoxIndirectA(MsgBoxParams);
end;

function ModifyMenu(               { is Dummy (Y) }
  hMnu: HMENU;
  uPosition: UINT;
  uFlags: UINT;
  uIDNewItem: UINT_PTR;
  lpNewItem: LPCTSTR
): BOOL;
begin
  ModifyMenu := ModifyMenuA(hMnu, uPosition, uFlags, uIDNewItem, lpNewItem);    
end;

function OemToChar(lpszSrc: LPCSTR; Out lpszDst: LPTSTR): BOOL;
begin
  OemToChar := OemToCharA(lpszSrc, lpszDst);
end;

function OemToCharBuff(
      lpszSrc: LPCSTR;
  Out lpszDst: LPTSTR;
      cchDstLength: DWORD
): BOOL;
begin
  OemToCharBuff := OemToCharBuffA(lpszSrc, lpszDst, cchDstLength);
end;


function PeekMessage(
  Out Msg: LPMSG;
      Wnd: HWND;
      wMsgFilterMin: UINT;
      wMsgFilterMax: UINT;
      wRemoveMsg: UINT
): BOOL; 
begin
  PeekMessage := PeekMessageA(Msg, Wnd, wMsgFilterMin, wMsgFilterMax, wRemoveMsg);
end;

function PostMessage(
  Wnd: HWND;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): BOOL; 
begin
  PostMessage := PostMessageA(Wnd, Msg, wwParam, llParam);
end;

function PostThreadMessage(
  idThread: DWORD;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): BOOL;
begin
  PostThreadMessage := PostThreadMessageA(idThread, Msg, wwParam, llParam);
end;

function RegisterClass(const wndClass: LPWNDCLASS): ATOM; 
begin
  RegisterClass := RegisterClassA(wndClass);
end;

function RegisterClassEx(lpwcx: LPWNDCLASSEX): ATOM; 
begin
  RegisterClassEx := RegisterClassExA(lpwcx);
end;

function RegisterClipboardFormat(lpszFormat: LPCTSTR): UINT; 
begin
  RegisterClipboardFormat := RegisterClipboardFormatA(lpszFormat);
end;

function RegisterWindowMessage(lpString: LPCTSTR): UINT; { is Dummy (Y) }
begin
  RegisterWindowMessage := RegisterWindowMessageA(lpString);
end;

function SendDlgItemMessage(
  hDlg: HWND;
  nIDDlgItem: Longint;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): LRESULT;
begin
  SendDlgItemMessage := SendDlgItemMessageA(hDlg, nIDDlgItem, Msg, wwParam, llParam);
end;

function SendMessage(
  Wnd: HWND;
  Msg: UINT;
  wwParam: WPARAM;
  llParam: LPARAM
): LRESULT;
begin
  SendMessage := SendMessageA(Wnd, Msg, wwParam, llParam);
end;

function SetClassLong(
  Wnd: HWND;
  nIndex: Longint;
  dwNewLong: LONG
): DWORD;
begin
  SetClassLong := SetClassLongA(Wnd, nIndex, dwNewlong);
end;

function SetDlgItemText(           { is Dummy (Y) }
  hDlg: HWND;
  nIDDlgItem: Longint;
  lpString: LPCTSTR
): BOOL;
begin
  SetDlgItemText := SetDlgItemTextA(hDlg, nIDDlgItem, lpString);
end;

function SetMenuItemInfo(          { is Dummy (Y) }
  Menu: HMENU;
  uItem: UINT;
  fByPosition: BOOL;
  lpmii: LPMENUITEMINFO
): BOOL;
begin
  SetMenuItemInfo := SetMenuItemInfoA(Menu, uItem, fByPosition, lpmii);
end;

function SetWindowsHookEx(          { is Dummy (Y) }
  idHook: Longint;
  lpfn: HOOKPROC;
  hMod: HINSTANCE;
  dwThreadId: DWORD
): HHOOK;
begin
  SetWindowsHookEx := SetWindowsHookExA(idHook, lpfn, hMod, dwThreadId);
end;

function SetWindowLong(
  Wnd: HWND;
  nIndex: Longint;
  dwNewLong: LONG
): LONG;
begin
  SetWindowLong := SetWindowLongA(Wnd, nIndex, dwNewLong);
end;

function SetWindowText(Wnd: HWND; lpString: LPCTSTR): BOOL;
begin
  SetWindowText := SetWindowTextA(Wnd, lpString);
end;

function SystemParametersInfo(      { is Dummy (Y) }
      uiAction: UINT;
      uiParam : UINT;
  var pvParam : PVOID;
      fWinIni : UINT
): BOOL;
begin
  SystemParametersInfo := SystemParametersInfoA(uiAction,uiParam,pvParam,fWinIni);
end;

function UnregisterClass(
   lpClassName: LPCTSTR;
   Instance: HINSTANCE
): BOOL;
begin
  UnregisterClass := UnregisterClassA(lpClassName, Instance);
end;

function WinHelp(                  { is Dummy (Y) }
  hWndMain: HWND;
  lpszHelp: LPCTSTR;
  uCommand: UINT;
  dwData: ULONG_PTR
): BOOL;
begin
  WinHelp := WinHelpA(hWndMain, lpszHelp, uCommand, dwData);
end;

function wsprintf(
  Out lpOut: LPTSTR;
      lpFmt: LPCTSTR;
  {_In_          ...} s: array of String
): Longint;
begin
  wsprintf := wsprintfA(lpOut, lpFmt, s);
end;

function wvsprintf(
  out lpOutput: LPTSTR;
      lpFmt: LPCTSTR;
      arglist: va_list
): Longint;
begin
  wvsprintf := wvsprintfA(lpOutput, lpFmt, arglist);
end;

function VkKeyScan(ch: TCHAR): SHORT;
begin
  VkKeyScan := VkKeyScanA(ch);
end;

function LoadString(
  Instance: HINSTANCE;
  uID: UINT;
  lpBuffer: LPTSTR;
  nBufferMax: Longint
): Longint;
begin
  LoadString := LoadStringA(Instance, uID, lpBuffer, nBufferMax);
end;

var MouseCaptures: THandleStack;

function GetCapture: HWND;
begin
  if not MouseCaptures.Empty
     then Result := HWND(MouseCaptures.CurrentHandle)
  else Result := 0;
end;

function ReleaseCapture: BOOL;
var wnd: HWND; success: BOOL;
begin
  success := not MouseCaptures.Empty;
  if success then MouseCaptures.Pop(wnd);
  Result := success;
end;

function SetCapture(wnd: HWND): HWND;
begin
  if not MouseCaptures.Empty
     then Result := MouseCaptures.CurrentHandle
  else Result := 0;
  MouseCaptures.Push(wnd);
end;

{ THandleStack }

function THandleStack.Empty: Boolean;
begin
  Result := Count <= 0
end;

procedure THandleStack.push(H: THandle);
begin
  FCurrentIndex := Add(H);
end;

procedure THandleStack.pop(out H: THandle);
begin
  if not Empty then
  H := Handle[FCurrentIndex];
  Delete(FCurrentIndex);
end;

{ THandleList }

function THandleList.GetHandle(Index: Integer): THandle;
begin
  Result := THandle(Items[Index]);
end;

function THandleList.Add(h: THandle): Integer;
var p: Pointer;
begin
  p := Pointer(h);
  Result := inherited Add(p);
end;

initialization
  MouseCaptures := THandleStack.Create;

finalization
  MouseCaptures.Free;

end.
